-- Package declaration
local _transfer = _G["github.com/eandre/groupauras/core/library/transfer"] or {}
_G["github.com/eandre/groupauras/core/library/transfer"] = _transfer

local builtins = _G.lunar_go_builtins

local _aura = _G["github.com/eandre/groupauras/core/aura"]
local _acecomm = _G["github.com/eandre/groupauras/pkg/ace/acecomm"]
local _luastrings = _G["github.com/eandre/lunar-wow/pkg/luastrings"]

_transfer.prefix = "GroupAuras"

_transfer.Send = function(aura, channel, target, key, f)
	local revision = _luastrings.ToString(aura.Revision)
	local msg = "AURA " .. aura.ID .. " " .. revision .. " " .. aura.Sig .. " " .. aura.Raw
	_acecomm.SendCommMessage(_transfer.prefix, msg, channel, target, "BULK", f, key)
end


_transfer.listeners = nil

_transfer.RegisterListener = function(l)
	_transfer.listeners = builtins.append(_transfer.listeners, l)
end

_transfer.onMessage = function(prefix, message, distribution, sender)
	if (not _luastrings.HasPrefix(message, "AURA ")) then
		return
	end
	local parts = _luastrings.Split(" ", message, 5)
	if builtins.length(parts) < 5 then
		return
	end
	local id = (parts[1 + 1] or "")
	local revision = _luastrings.ToInt((parts[2 + 1] or ""))
	local sig = (parts[3 + 1] or "")
	local raw = (parts[4 + 1] or "")
	local a = { ["ID"] = id, ["Revision"] = revision, ["Sig"] = sig, ["Raw"] = raw, ["Name"] = "", ["Author"] = "", ["OnUpdate"] = "", ["OnActivate"] = "", ["OnDeactivate"] = ""}
	for _, l in builtins.slice_iter(_transfer.listeners or {}) do
		l:OnAuraReceived(a)
	end
end

builtins.add_init(function()
	_acecomm.RegisterComm(_transfer.prefix, _transfer.onMessage)
end)

