-- Package declaration
local _draw = _G["github.com/eandre/groupauras/pkg/draw"] or {}
_G["github.com/eandre/groupauras/pkg/draw"] = _draw

local builtins = _G.lunar_go_builtins

local _luamath = _G["github.com/eandre/lunar-wow/pkg/luamath"]
local _wow = _G["github.com/eandre/lunar-wow/pkg/wow"]

_draw.activePoints = {}

_draw.updateInterval = 1 / 60.0

_draw.updateTotal = 0

_draw.markPointActive = function(p)
	_draw.activePoints[p] = true
end

_draw.markPointInactive = function(p)
	builtins.delete(_draw.activePoints, p)
end

_draw.onUpdate = function(dt)
	_draw.updateTotal = _draw.updateTotal + dt
	if _draw.updateTotal > _draw.updateInterval then
		local steps = _luamath.Floor(_draw.updateTotal / _draw.updateInterval)
		local elapsed = _draw.updateInterval * (steps)
		_draw.updateTotal = _draw.updateTotal - elapsed
		for p in pairs(_draw.activePoints or {}) do
			p:update()
		end
	end
end

builtins.add_init(function()
	_wow.RegisterUpdate(_draw.onUpdate)
end)

